Index: libcfa/prelude/extras.c
===================================================================
--- libcfa/prelude/extras.c	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ libcfa/prelude/extras.c	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -3,5 +3,4 @@
 #include <uchar.h>					// char16_t, char32_t
 #include <wchar.h>					// wchar_t
-#include <stdlib.h>					// malloc, free, getenv, exit, atexit, abort, printf
+#include <stdlib.h>					// malloc, free, exit, atexit, abort
 #include <stdio.h>					// printf
-#include <string.h>					// strlen, strcmp, strncmp
Index: libcfa/prelude/extras.regx2
===================================================================
--- libcfa/prelude/extras.regx2	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ libcfa/prelude/extras.regx2	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -1,10 +1,6 @@
 extern void \*malloc[^;]*;
 extern void free[^;]*;
-extern char \*getenv[^;]*;
 extern void exit[^;]*;
 extern int atexit[^;]*;
 extern void abort[^;]*;
 extern int printf[^;]*;
-int strcmp[^;]*;
-int strncmp[^;]*;
-size_t strlen[^;]*;
Index: libcfa/src/Makefile.am
===================================================================
--- libcfa/src/Makefile.am	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ libcfa/src/Makefile.am	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -11,6 +11,6 @@
 ## Created On       : Sun May 31 08:54:01 2015
 ## Last Modified By : Peter A. Buhr
-## Last Modified On : Mon Sep 18 17:06:56 2023
-## Update Count     : 264
+## Last Modified On : Wed Aug 30 21:22:45 2023
+## Update Count     : 263
 ###############################################################################
 
@@ -118,5 +118,5 @@
 	concurrency/mutex_stmt.hfa \
 	concurrency/channel.hfa \
-	concurrency/actor.hfa
+	concurrency/actor.hfa 
 
 inst_thread_headers_src = \
@@ -130,6 +130,5 @@
 	concurrency/mutex.hfa \
 	concurrency/select.hfa \
-	concurrency/thread.hfa \
-	concurrency/cofor.hfa
+	concurrency/thread.hfa
 
 thread_libsrc = ${inst_thread_headers_src} ${inst_thread_headers_src:.hfa=.cfa} \
Index: libcfa/src/clock.hfa
===================================================================
--- libcfa/src/clock.hfa	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ libcfa/src/clock.hfa	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -10,6 +10,6 @@
 // Created On       : Thu Apr 12 14:36:06 2018
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Sat Sep  9 14:07:17 2023
-// Update Count     : 30
+// Last Modified On : Sun Apr 18 08:12:16 2021
+// Update Count     : 28
 //
 
@@ -91,18 +91,18 @@
 	// discontinuous jumps when the OS is not running the kernal thread. A duration is returned because the value is
 	// relative and cannot be converted to real-time (wall-clock) time.
-	Duration processor_cpu() {							// non-monotonic duration of kernel thread
+	Duration processor() {								// non-monotonic duration of kernel thread
 		timespec ts;
 		clock_gettime( CLOCK_THREAD_CPUTIME_ID, &ts );
 		return (Duration){ ts };
-	} // processor_cpu
+	} // processor
 
 	// Program CPU-time watch measures CPU time consumed by all processors (kernel threads) in the UNIX process.  This
 	// watch is affected by discontinuous jumps when the OS is not running the kernel threads. A duration is returned
 	// because the value is relative and cannot be converted to real-time (wall-clock) time.
-	Duration program_cpu() {							// non-monotonic duration of program CPU
+	Duration program() {								// non-monotonic duration of program CPU
 		timespec ts;
 		clock_gettime( CLOCK_PROCESS_CPUTIME_ID, &ts );
 		return (Duration){ ts };
-	} // program_cpu
+	} // program
 
 	// Monotonic duration from machine boot and including system suspension. This watch is unaffected by discontinuous
Index: libcfa/src/collections/string.cfa
===================================================================
--- libcfa/src/collections/string.cfa	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ libcfa/src/collections/string.cfa	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -157,28 +157,19 @@
 // Comparison
 
-int  cmp (const string &s1, const string &s2) { return cmp(*s1.inner ,  *s2.inner); }
-bool ?==?(const string &s1, const string &s2) { return     *s1.inner == *s2.inner ; }
-bool ?!=?(const string &s1, const string &s2) { return     *s1.inner != *s2.inner ; }
-bool ?>? (const string &s1, const string &s2) { return     *s1.inner >  *s2.inner ; }
-bool ?>=?(const string &s1, const string &s2) { return     *s1.inner >= *s2.inner ; }
-bool ?<=?(const string &s1, const string &s2) { return     *s1.inner <= *s2.inner ; }
-bool ?<? (const string &s1, const string &s2) { return     *s1.inner <  *s2.inner ; }
-
-int  cmp (const string &s1, const char*   s2) { return cmp(*s1.inner ,   s2      ); }
-bool ?==?(const string &s1, const char*   s2) { return     *s1.inner ==  s2       ; }
-bool ?!=?(const string &s1, const char*   s2) { return     *s1.inner !=  s2       ; }
-bool ?>? (const string &s1, const char*   s2) { return     *s1.inner >   s2       ; }
-bool ?>=?(const string &s1, const char*   s2) { return     *s1.inner >=  s2       ; }
-bool ?<=?(const string &s1, const char*   s2) { return     *s1.inner <=  s2       ; }
-bool ?<? (const string &s1, const char*   s2) { return     *s1.inner <   s2       ; }
-
-int  cmp (const char*   s1, const string &s2) { return cmp( s1       ,  *s2.inner); }
-bool ?==?(const char*   s1, const string &s2) { return      s1       == *s2.inner ; }
-bool ?!=?(const char*   s1, const string &s2) { return      s1       != *s2.inner ; }
-bool ?>? (const char*   s1, const string &s2) { return      s1       >  *s2.inner ; }
-bool ?>=?(const char*   s1, const string &s2) { return      s1       >= *s2.inner ; }
-bool ?<=?(const char*   s1, const string &s2) { return      s1       <= *s2.inner ; }
-bool ?<? (const char*   s1, const string &s2) { return      s1       <  *s2.inner ; }
-
+bool ?==?(const string & s, const string & other) {
+    return *s.inner == *other.inner;
+}
+
+bool ?!=?(const string & s, const string & other) {
+    return *s.inner != *other.inner;
+}
+
+bool ?==?(const string & s, const char * other) {
+    return *s.inner == other;
+}
+
+bool ?!=?(const string & s, const char * other) {
+    return *s.inner != other;
+}
 
 ////////////////////////////////////////////////////////
Index: libcfa/src/collections/string.hfa
===================================================================
--- libcfa/src/collections/string.hfa	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ libcfa/src/collections/string.hfa	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -116,28 +116,8 @@
 
 // Comparisons
-int  cmp (const string &, const string &);
-bool ?==?(const string &, const string &);
-bool ?!=?(const string &, const string &);
-bool ?>? (const string &, const string &);
-bool ?>=?(const string &, const string &);
-bool ?<=?(const string &, const string &);
-bool ?<? (const string &, const string &);
-
-int  cmp (const string &, const char*);
-bool ?==?(const string &, const char*);
-bool ?!=?(const string &, const char*);
-bool ?>? (const string &, const char*);
-bool ?>=?(const string &, const char*);
-bool ?<=?(const string &, const char*);
-bool ?<? (const string &, const char*);
-
-int  cmp (const char*, const string &);
-bool ?==?(const char*, const string &);
-bool ?!=?(const char*, const string &);
-bool ?>? (const char*, const string &);
-bool ?>=?(const char*, const string &);
-bool ?<=?(const char*, const string &);
-bool ?<? (const char*, const string &);
-
+bool ?==?(const string & s, const string & other);
+bool ?!=?(const string & s, const string & other);
+bool ?==?(const string & s, const char * other);
+bool ?!=?(const string & s, const char * other);
 
 // Slicing
Index: libcfa/src/collections/string_res.cfa
===================================================================
--- libcfa/src/collections/string_res.cfa	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ libcfa/src/collections/string_res.cfa	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -637,42 +637,19 @@
 // Comparisons
 
-int cmp(const string_res &s1, const string_res &s2) {
-    // return 0;
-    int ans1 = memcmp(s1.Handle.s, s2.Handle.s, min(s1.Handle.lnth, s2.Handle.lnth));
-    if (ans1 != 0) return ans1;
-    return s1.Handle.lnth - s2.Handle.lnth;
-}
-
-bool ?==?(const string_res &s1, const string_res &s2) { return cmp(s1, s2) == 0; }
-bool ?!=?(const string_res &s1, const string_res &s2) { return cmp(s1, s2) != 0; }
-bool ?>? (const string_res &s1, const string_res &s2) { return cmp(s1, s2) >  0; }
-bool ?>=?(const string_res &s1, const string_res &s2) { return cmp(s1, s2) >= 0; }
-bool ?<=?(const string_res &s1, const string_res &s2) { return cmp(s1, s2) <= 0; }
-bool ?<? (const string_res &s1, const string_res &s2) { return cmp(s1, s2) <  0; }
-
-int cmp (const string_res &s1, const char* s2) {
-    string_res s2x = s2;
-    return cmp(s1, s2x);
-}
-
-bool ?==?(const string_res &s1, const char* s2) { return cmp(s1, s2) == 0; }
-bool ?!=?(const string_res &s1, const char* s2) { return cmp(s1, s2) != 0; }
-bool ?>? (const string_res &s1, const char* s2) { return cmp(s1, s2) >  0; }
-bool ?>=?(const string_res &s1, const char* s2) { return cmp(s1, s2) >= 0; }
-bool ?<=?(const string_res &s1, const char* s2) { return cmp(s1, s2) <= 0; }
-bool ?<? (const string_res &s1, const char* s2) { return cmp(s1, s2) <  0; }
-
-int cmp (const char* s1, const string_res & s2) {
-    string_res s1x = s1;
-    return cmp(s1x, s2);
-}
-
-bool ?==?(const char* s1, const string_res &s2) { return cmp(s1, s2) == 0; }
-bool ?!=?(const char* s1, const string_res &s2) { return cmp(s1, s2) != 0; }
-bool ?>? (const char* s1, const string_res &s2) { return cmp(s1, s2) >  0; }
-bool ?>=?(const char* s1, const string_res &s2) { return cmp(s1, s2) >= 0; }
-bool ?<=?(const char* s1, const string_res &s2) { return cmp(s1, s2) <= 0; }
-bool ?<? (const char* s1, const string_res &s2) { return cmp(s1, s2) <  0; }
-
+
+bool ?==?(const string_res &s1, const string_res &s2) {
+    return ByteCmp( s1.Handle.s, 0, s1.Handle.lnth, s2.Handle.s, 0, s2.Handle.lnth) == 0;
+}
+
+bool ?!=?(const string_res &s1, const string_res &s2) {
+    return !(s1 == s2);
+}
+bool ?==?(const string_res &s, const char* other) {
+    string_res sother = other;
+    return s == sother;
+}
+bool ?!=?(const string_res &s, const char* other) {
+    return !(s == other);
+}
 
 
Index: libcfa/src/collections/string_res.hfa
===================================================================
--- libcfa/src/collections/string_res.hfa	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ libcfa/src/collections/string_res.hfa	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -142,27 +142,8 @@
 
 // Comparisons
-int  cmp (const string_res &, const string_res &);
-bool ?==?(const string_res &, const string_res &);
-bool ?!=?(const string_res &, const string_res &);
-bool ?>? (const string_res &, const string_res &);
-bool ?>=?(const string_res &, const string_res &);
-bool ?<=?(const string_res &, const string_res &);
-bool ?<? (const string_res &, const string_res &);
-
-int  cmp (const string_res &, const char*);
-bool ?==?(const string_res &, const char*);
-bool ?!=?(const string_res &, const char*);
-bool ?>? (const string_res &, const char*);
-bool ?>=?(const string_res &, const char*);
-bool ?<=?(const string_res &, const char*);
-bool ?<? (const string_res &, const char*);
-
-int  cmp (const char*, const string_res &);
-bool ?==?(const char*, const string_res &);
-bool ?!=?(const char*, const string_res &);
-bool ?>? (const char*, const string_res &);
-bool ?>=?(const char*, const string_res &);
-bool ?<=?(const char*, const string_res &);
-bool ?<? (const char*, const string_res &);
+bool ?==?(const string_res &s, const string_res &other);
+bool ?!=?(const string_res &s, const string_res &other);
+bool ?==?(const string_res &s, const char* other);
+bool ?!=?(const string_res &s, const char* other);
 
 // String search
Index: libcfa/src/common.hfa
===================================================================
--- libcfa/src/common.hfa	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ libcfa/src/common.hfa	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -69,12 +69,12 @@
 	T min( T v1, T v2 ) { return v1 < v2 ? v1 : v2; }
 
-	forall( T, Ts... | { T min( T, T ); T min( T, T, Ts ); } )
-	T min( T v1, T v2, T v3, Ts vs ) { return min( min( v1, v2 ), v3, vs ); }
+	forall( T, Ts... | { T min( T, T ); T min( T, Ts ); } )
+	T min( T v1, T v2, Ts vs ) { return min( min( v1, v2 ), vs ); }
 
 	forall( T | { int ?>?( T, T ); } )
 	T max( T v1, T v2 ) { return v1 > v2 ? v1 : v2; }
 
-	forall( T, Ts... | { T max( T, T ); T max( T, T, Ts ); } )
-	T max( T v1, T v2, T v3, Ts vs ) { return max( max( v1, v2 ), v3, vs ); }
+	forall( T, Ts... | { T max( T, T ); T max( T, Ts ); } )
+	T max( T v1, T v2, Ts vs ) { return max( max( v1, v2 ), vs ); }
 
 	forall( T | { T min( T, T ); T max( T, T ); } )
Index: libcfa/src/concurrency/coroutine.cfa
===================================================================
--- libcfa/src/concurrency/coroutine.cfa	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ libcfa/src/concurrency/coroutine.cfa	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -10,6 +10,6 @@
 // Created On       : Mon Nov 28 12:27:26 2016
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Mon Sep 18 21:47:12 2023
-// Update Count     : 25
+// Last Modified On : Thu Feb 16 15:34:46 2023
+// Update Count     : 24
 //
 
@@ -364,5 +364,5 @@
 // resume non local exception at receiver (i.e. enqueue in ehm buffer)
 forall(exceptT *, T & | ehm_resume_at( exceptT, T ))
-void resumeAt( T & receiver, exceptT & ex ) libcfa_public {
+void resumeAt( T & receiver, exceptT & ex )  libcfa_public {
     coroutine$ * cor = get_coroutine( receiver );
     nonlocal_exception * nl_ex = alloc();
Index: libcfa/src/concurrency/kernel/cluster.hfa
===================================================================
--- libcfa/src/concurrency/kernel/cluster.hfa	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ libcfa/src/concurrency/kernel/cluster.hfa	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -31,6 +31,6 @@
 
 // warn normally all ints
-#define warn_large_before warnf( !strict || old_avg < 33_000_000_000, "Suspiciously large previous average: %'llu (%llx), %'" PRId64 "ms \n", old_avg, old_avg, program_cpu()`ms )
-#define warn_large_after warnf( !strict || ret < 33_000_000_000, "Suspiciously large new average after %'" PRId64 "ms cputime: %'llu (%llx) from %'llu-%'llu (%'llu, %'llu) and %'llu\n", program_cpu()`ms, ret, ret, currtsc, intsc, new_val, new_val / 1000000, old_avg )
+#define warn_large_before warnf( !strict || old_avg < 33_000_000_000, "Suspiciously large previous average: %'llu (%llx), %'" PRId64 "ms \n", old_avg, old_avg, program()`ms )
+#define warn_large_after warnf( !strict || ret < 33_000_000_000, "Suspiciously large new average after %'" PRId64 "ms cputime: %'llu (%llx) from %'llu-%'llu (%'llu, %'llu) and %'llu\n", program()`ms, ret, ret, currtsc, intsc, new_val, new_val / 1000000, old_avg )
 
 // 8X linear factor is just 8 * x
@@ -42,6 +42,6 @@
 static inline __readyQ_avg_t __to_readyQ_avg(unsigned long long intsc) { if(unlikely(0 == intsc)) return 0.0; else return log2((__readyQ_avg_t)intsc); }
 
-#define warn_large_before warnf( !strict || old_avg < 35.0, "Suspiciously large previous average: %'lf, %'" PRId64 "ms \n", old_avg, program_cpu()`ms )
-#define warn_large_after warnf( !strict || ret < 35.3, "Suspiciously large new average after %'" PRId64 "ms cputime: %'lf from %'llu-%'llu (%'llu, %'llu) and %'lf\n", program_cpu()`ms, ret, currtsc, intsc, new_val, new_val / 1000000, old_avg ); \
+#define warn_large_before warnf( !strict || old_avg < 35.0, "Suspiciously large previous average: %'lf, %'" PRId64 "ms \n", old_avg, program()`ms )
+#define warn_large_after warnf( !strict || ret < 35.3, "Suspiciously large new average after %'" PRId64 "ms cputime: %'lf from %'llu-%'llu (%'llu, %'llu) and %'lf\n", program()`ms, ret, currtsc, intsc, new_val, new_val / 1000000, old_avg ); \
 verify(ret >= 0)
 
Index: libcfa/src/heap.cfa
===================================================================
--- libcfa/src/heap.cfa	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ libcfa/src/heap.cfa	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -10,6 +10,6 @@
 // Created On       : Tue Dec 19 21:58:35 2017
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Mon Sep 11 11:21:10 2023
-// Update Count     : 1615
+// Last Modified On : Wed Aug  2 18:48:30 2023
+// Update Count     : 1614
 //
 
@@ -691,16 +691,4 @@
 	return stats;
 } // collectStats
-
-static inline void clearStats() {
-	lock( mgrLock );
-
-	// Zero the heap master and all active thread heaps.
-	HeapStatisticsCtor( heapMaster.stats );
-	for ( Heap * heap = heapMaster.heapManagersList; heap; heap = heap->nextHeapManager ) {
-		HeapStatisticsCtor( heap->stats );
-	} // for
-
-	unlock( mgrLock );
-} // clearStats
 #endif // __STATISTICS__
 
@@ -1568,17 +1556,4 @@
 
 
-	// Zero the heap master and all active thread heaps.
-	void malloc_stats_clear() {
-		#ifdef __STATISTICS__
-		clearStats();
-		#else
-		#define MALLOC_STATS_MSG "malloc_stats statistics disabled.\n"
-		if ( write( STDERR_FILENO, MALLOC_STATS_MSG, sizeof( MALLOC_STATS_MSG ) - 1 /* size includes '\0' */ ) == -1 ) {
-			abort( "**** Error **** write failed in malloc_stats" );
-		} // if
-		#endif // __STATISTICS__
-	} // malloc_stats_clear
-
-
 	// Changes the file descriptor where malloc_stats() writes statistics.
 	int malloc_stats_fd( int fd __attribute__(( unused )) ) libcfa_public {
Index: libcfa/src/heap.hfa
===================================================================
--- libcfa/src/heap.hfa	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ libcfa/src/heap.hfa	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -10,6 +10,6 @@
 // Created On       : Tue May 26 11:23:55 2020
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Mon Sep 11 11:18:18 2023
-// Update Count     : 24
+// Last Modified On : Tue Oct  4 19:08:55 2022
+// Update Count     : 23
 // 
 
@@ -43,5 +43,4 @@
 	size_t malloc_mmap_start();							// crossover allocation size from sbrk to mmap
 	size_t malloc_unfreed();							// heap unfreed size (bytes)
-	void malloc_stats_clear();							// clear heap statistics
 } // extern "C"
 
Index: libcfa/src/iostream.cfa
===================================================================
--- libcfa/src/iostream.cfa	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ libcfa/src/iostream.cfa	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -1,3 +1,2 @@
-
 //
 // Cforall Version 1.0.0 Copyright (C) 2015 University of Waterloo
@@ -977,10 +976,5 @@
 		if ( f.flags.ignore ) { fmtstr[1] = '*'; start += 1; }
 		// no maximum width necessary because text ignored => width is read width
-		if ( f.wd != -1 ) {
-			// wd is buffer bytes available (for input chars + null terminator)
-			// rwd is count of input chars
-			int rwd = f.flags.rwd ? f.wd : (f.wd - 1);
-			start += sprintf( &fmtstr[start], "%d", rwd );
-		}
+		if ( f.wd != -1 ) { start += sprintf( &fmtstr[start], "%d", f.wd ); }
 
 		if ( ! scanset ) {
@@ -999,5 +993,5 @@
 		} // if
 
-		int check = f.wd - 2;
+		int check = f.wd - 1;
 		if ( ! f.flags.rwd ) f.s[check] = '\0';			// insert sentinel
 		len = fmt( is, fmtstr, f.s );
Index: src/AST/Util.cpp
===================================================================
--- src/AST/Util.cpp	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ src/AST/Util.cpp	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -104,13 +104,4 @@
 	}
 	assertf( false, "Member not found." );
-}
-
-template<typename node_t>
-void oneOfExprOrType( const node_t * node ) {
-	if ( node->expr ) {
-		assertf( node->expr && !node->type, "Exactly one of expr or type should be set." );
-	} else {
-		assertf( !node->expr && node->type, "Exactly one of expr or type should be set." );
-	}
 }
 
@@ -161,14 +152,4 @@
 	}
 
-	void previsit( const SizeofExpr * node ) {
-		previsit( (const ParseNode *)node );
-		oneOfExprOrType( node );
-	}
-
-	void previsit( const AlignofExpr * node ) {
-		previsit( (const ParseNode *)node );
-		oneOfExprOrType( node );
-	}
-
 	void previsit( const StructInstType * node ) {
 		previsit( (const Node *)node );
@@ -200,6 +181,4 @@
 /// referring to is in scope by the structural rules of code.
 // Any escapes marked with a bug should be removed once the bug is fixed.
-// This is a separate pass because of it changes the visit pattern and
-// must always be run on the entire translation unit.
 struct InScopeCore : public ast::WithShortCircuiting {
 	ScopedSet<DeclWithType const *> typedDecls;
Index: src/ControlStruct/MultiLevelExit.cpp
===================================================================
--- src/ControlStruct/MultiLevelExit.cpp	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ src/ControlStruct/MultiLevelExit.cpp	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -10,6 +10,6 @@
 // Created On       : Mon Nov  1 13:48:00 2021
 // Last Modified By : Andrew Beach
-// Last Modified On : Fri Sep  8 17:04:00 2023
-// Update Count     : 36
+// Last Modified On : Wed Sep  6 12:00:00 2023
+// Update Count     : 35
 //
 
@@ -27,14 +27,4 @@
 
 namespace {
-
-/// The return context is used to remember if returns are allowed and if
-/// not, why not. It is the nearest local control flow blocking construct.
-enum ReturnContext {
-	MayReturn,
-	InTryWithHandler,
-	InResumeHandler,
-	InTerminateHandler,
-	InFinally,
-};
 
 class Entry {
@@ -136,5 +126,4 @@
 	void previsit( const TryStmt * );
 	void postvisit( const TryStmt * );
-	void previsit( const CatchClause * );
 	void previsit( const FinallyClause * );
 
@@ -145,5 +134,5 @@
 	vector<Entry> enclosing_control_structures;
 	Label break_label;
-	ReturnContext ret_context;
+	bool inFinally;
 
 	template<typename LoopNode>
@@ -155,6 +144,4 @@
 		const list<ptr<Stmt>> & kids, bool caseClause );
 
-	void enterSealedContext( ReturnContext );
-
 	template<typename UnaryPredicate>
 	auto findEnclosingControlStructure( UnaryPredicate pred ) {
@@ -170,5 +157,5 @@
 MultiLevelExitCore::MultiLevelExitCore( const LabelToStmt & lt ) :
 	target_table( lt ), break_label( CodeLocation(), "" ),
-	ret_context( ReturnContext::MayReturn )
+	inFinally( false )
 {}
 
@@ -501,24 +488,7 @@
 
 void MultiLevelExitCore::previsit( const ReturnStmt * stmt ) {
-	char const * context;
-	switch ( ret_context ) {
-	case ReturnContext::MayReturn:
-		return;
-	case ReturnContext::InTryWithHandler:
-		context = "try statement with a catch clause";
-		break;
-	case ReturnContext::InResumeHandler:
-		context = "catchResume clause";
-		break;
-	case ReturnContext::InTerminateHandler:
-		context = "catch clause";
-		break;
-	case ReturnContext::InFinally:
-		context = "finally clause";
-		break;
-	default:
-		assert(0);
-	}
-	SemanticError( stmt->location, toString( "'return' may not appear in a ", context ) );
+	if ( inFinally ) {
+		SemanticError( stmt->location, "'return' may not appear in a finally clause" );
+	}
 }
 
@@ -530,11 +500,4 @@
 		GuardAction([this](){ enclosing_control_structures.pop_back(); } );
 	}
-
-	// Try statements/try blocks are only sealed with a termination handler.
-	for ( auto clause : stmt->handlers ) {
-		if ( ast::Terminate == clause->kind ) {
-			return enterSealedContext( ReturnContext::InTryWithHandler );
-		}
-	}
 }
 
@@ -549,12 +512,8 @@
 }
 
-void MultiLevelExitCore::previsit( const CatchClause * clause ) {
-	ReturnContext context = ( ast::Terminate == clause->kind )
-		? ReturnContext::InTerminateHandler : ReturnContext::InResumeHandler;
-	enterSealedContext( context );
-}
-
 void MultiLevelExitCore::previsit( const FinallyClause * ) {
-	enterSealedContext( ReturnContext::InFinally );
+	GuardAction([this, old = std::move( enclosing_control_structures)](){ enclosing_control_structures = std::move(old); });
+	enclosing_control_structures = vector<Entry>();
+	GuardValue( inFinally ) = true;
 }
 
@@ -658,10 +617,4 @@
 }
 
-void MultiLevelExitCore::enterSealedContext( ReturnContext enter_context ) {
-	GuardAction([this, old = std::move(enclosing_control_structures)](){ enclosing_control_structures = std::move(old); });
-	enclosing_control_structures = vector<Entry>();
-	GuardValue( ret_context ) = enter_context;
-}
-
 } // namespace
 
Index: src/GenPoly/GenPoly.cc
===================================================================
--- src/GenPoly/GenPoly.cc	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ src/GenPoly/GenPoly.cc	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -48,9 +48,8 @@
 		}
 
-		bool hasPolyParams( const std::vector<ast::ptr<ast::Expr>> & params, const ast::TypeSubstitution * env ) {
-			for ( auto &param : params ) {
-				auto paramType = param.as<ast::TypeExpr>();
-				assertf( paramType, "Aggregate parameters should be type expressions" );
-				if ( isPolyType( paramType->type, env ) ) return true;
+		bool hasPolyParams( const std::vector<ast::ptr<ast::Expr>> & params, const ast::TypeSubstitution * env) {
+			for (auto &param : params) {
+				auto paramType = param.strict_as<ast::TypeExpr>();
+				if (isPolyType(paramType->type, env)) return true;
 			}
 			return false;
@@ -63,13 +62,4 @@
 				assertf(paramType, "Aggregate parameters should be type expressions");
 				if ( isPolyType( paramType->get_type(), tyVars, env ) ) return true;
-			}
-			return false;
-		}
-
-		bool hasPolyParams( const std::vector<ast::ptr<ast::Expr>> & params, const TypeVarMap & typeVars, const ast::TypeSubstitution * env ) {
-			for ( auto & param : params ) {
-				auto paramType = param.as<ast::TypeExpr>();
-				assertf( paramType, "Aggregate parameters should be type expressions" );
-				if ( isPolyType( paramType->type, typeVars, env ) ) return true;
 			}
 			return false;
@@ -195,4 +185,19 @@
 	}
 
+	const ast::Type * isPolyType(const ast::Type * type, const TyVarMap & tyVars, const ast::TypeSubstitution * env) {
+		type = replaceTypeInst( type, env );
+
+		if ( auto typeInst = dynamic_cast< const ast::TypeInstType * >( type ) ) {
+			if ( tyVars.contains( typeInst->typeString() ) ) return type;
+		} else if ( auto arrayType = dynamic_cast< const ast::ArrayType * >( type ) ) {
+			return isPolyType( arrayType->base, env );
+		} else if ( auto structType = dynamic_cast< const ast::StructInstType* >( type ) ) {
+			if ( hasPolyParams( structType->params, env ) ) return type;
+		} else if ( auto unionType = dynamic_cast< const ast::UnionInstType* >( type ) ) {
+			if ( hasPolyParams( unionType->params, env ) ) return type;
+		}
+		return nullptr;
+	}
+
 const ast::Type * isPolyType( const ast::Type * type,
 		const TypeVarMap & typeVars, const ast::TypeSubstitution * subst ) {
@@ -202,9 +207,9 @@
 		if ( typeVars.contains( *inst ) ) return type;
 	} else if ( auto array = dynamic_cast< const ast::ArrayType * >( type ) ) {
-		return isPolyType( array->base, typeVars, subst );
+		return isPolyType( array->base, subst );
 	} else if ( auto sue = dynamic_cast< const ast::StructInstType * >( type ) ) {
-		if ( hasPolyParams( sue->params, typeVars, subst ) ) return type;
+		if ( hasPolyParams( sue->params, subst ) ) return type;
 	} else if ( auto sue = dynamic_cast< const ast::UnionInstType * >( type ) ) {
-		if ( hasPolyParams( sue->params, typeVars, subst ) ) return type;
+		if ( hasPolyParams( sue->params, subst ) ) return type;
 	}
 	return nullptr;
Index: tests/concurrency/actors/dynamic.cfa
===================================================================
--- tests/concurrency/actors/dynamic.cfa	(revision deda7e6002cc711be5c0af09984cec24300d5990)
+++ tests/concurrency/actors/dynamic.cfa	(revision c1e66d966aadf6846330871033458d4a398bd576)
@@ -9,57 +9,61 @@
 struct derived_actor { inline actor; };
 struct derived_msg {
-	inline message;
-	int cnt;
+    inline message;
+    int cnt;
 };
 
 void ?{}( derived_msg & this, int cnt ) {
-	set_allocation( this, Delete );
-	this.cnt = cnt;
+    ((message &) this){ Delete };
+    this.cnt = cnt;
 }
 void ?{}( derived_msg & this ) { ((derived_msg &)this){ 0 }; }
 
 allocation receive( derived_actor & receiver, derived_msg & msg ) {
-	if ( msg.cnt >= Times ) {
-		sout | "Done";
-		return Delete;
-	}
-	derived_msg * d_msg = alloc();
-	(*d_msg){ msg.cnt + 1 };
-	derived_actor * d_actor = alloc();
-	(*d_actor){};
-	*d_actor | *d_msg;
-	return Delete;
+    if ( msg.cnt >= Times ) {
+        sout | "Done";
+        return Delete;
+    }
+    derived_msg * d_msg = alloc();
+    (*d_msg){ msg.cnt + 1 };
+    derived_actor * d_actor = alloc();
+    (*d_actor){};
+    *d_actor | *d_msg;
+    return Delete;
 }
 
 int main( int argc, char * argv[] ) {
-	switch ( argc ) {
+    switch ( argc ) {
 	  case 2:
 		if ( strcmp( argv[1], "d" ) != 0 ) {			// default ?
-			Times = ato( argv[1] );
-			if ( Times < 1 ) fallthru default;
+			Times = atoi( argv[1] );
+			if ( Times < 1 ) goto Usage;
 		} // if
 	  case 1:											// use defaults
 		break;
 	  default:
-		exit | "Usage: " | argv[0] | " [ times (> 0) ]";
+	  Usage:
+		sout | "Usage: " | argv[0] | " [ times (> 0) ]";
+		exit( EXIT_FAILURE );
 	} // switch
 
-	sout | "starting";
+    printf("starting\n");
 
-	executor e{ 0, 1, 1, false };
-	start_actor_system( e );
+    executor e{ 0, 1, 1, false };
+    start_actor_system( e );
 
-	sout | "started";
+    printf("started\n");
 
-	derived_msg * d_msg = alloc();
-	(*d_msg){};
-	derived_actor * d_actor = alloc();
-	(*d_actor){};
-	*d_actor | *d_msg;
+    derived_msg * d_msg = alloc();
+    (*d_msg){};
+    derived_actor * d_actor = alloc();
+    (*d_actor){};
+    *d_actor | *d_msg;
 
-	sout | "stopping";
+    printf("stopping\n");
 
-	stop_actor_system();
+    stop_actor_system();
 
-	sout | "stopped";
+    printf("stopped\n");
+
+    return 0;
 }
